=== share/CMakeLists.txt ===
add_subdirectory(fiat)
