=== share/fiat/CMakeLists.txt ===
add_subdirectory(drhook)
