=== debian/changelog ===
fiat-ecmwf (1.6.1-1) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * New upstream release
  * Add d/watch file
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Aug 2025 16:35:22 +0100
