=== debian/control ===
Source: fiat-ecmwf
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.3.2),
  python3-all-dev,
  libfckit-dev (>= 0.11.0-5),
  libfckit-utils,
  mpi-default-dev,
  chrpath
Standards-Version: 4.7.2
Homepage: https://github.com/ecmwf-ifs/fiat
Vcs-Browser: https://salsa.debian.org/science-team/fiat.git
Vcs-Git: https://salsa.debian.org/science-team/fiat.git -b debian/latest

Package: libfiat-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fortran IFS and Arpege Toolkit - libray
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.


Package: fiat-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libfiat-0 (= ${binary:Version}) 
Description: Fortran IFS and Arpege Toolkit - utilities
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfiat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: ecbuild, ${fortran:Recommends}
Depends:  ${misc:Depends}, ${fortran:Depends},
 libfiat-0 (= ${binary:Version}),
 fiat-utils (= ${binary:Version}),
 libfckit-dev
Description: Fortran IFS and Arpege Toolkit - development files
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
