## fiat-ecmwf 1.6.2

=== debian/changelog ===
fiat-ecmwf (1.6.2-2) unstable; urgency=medium

  * Now use dh_fortran get_fmoddir
  * Move from dh-fortran-mod to dh-fortran

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 17:00:46 +0000

fiat-ecmwf (1.6.2-1) unstable; urgency=medium

  * Upstream release 1.6.2
  * Change vcs-browser to canonical form
  * Update d/copyright to match licenserecon

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Dec 2025 07:49:16 +0000
