=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
-  dh-fortran-mod (>= 0.31),
+  dh-fortran (>= 0.50),
   ecbuild (>= 3.3.2),
   python3-all-dev,
   libfckit-dev (>= 0.11.0-5),
@@ -14,7 +14,7 @@
   chrpath
 Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf-ifs/fiat
-Vcs-Browser: https://salsa.debian.org/science-team/fiat.git
+Vcs-Browser: https://salsa.debian.org/science-team/fiat
 Vcs-Git: https://salsa.debian.org/science-team/fiat.git -b debian/latest
 
 Package: libfiat-0
